// myDlg.cpp : implementation file
//

#include "stdafx.h"
#include "my.h"
#include "myDlg.h"
#include "MyStream.h"
#include "MyTime.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CmyDlg dialog

CmyDlg::CmyDlg(CWnd* pParent) : CDialog(CmyDlg::IDD, pParent){
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CmyDlg::DoDataExchange(CDataExchange* pDX){
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CmyDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CmyDlg::OnBnClickedRUN)
  ON_BN_CLICKED(IDC_BUTTON_RIGHT, &CmyDlg::OnBnClickedButtonRight)
  ON_BN_CLICKED(IDC_BUTTON_LEFT, &CmyDlg::OnBnClickedButtonLeft)
  ON_BN_CLICKED(IDC_BUTTON4, &CmyDlg::OnBnClickedButton4)
  ON_BN_CLICKED(IDC_BUTTON5, &CmyDlg::OnBnClickedButton5)
  ON_BN_CLICKED(IDC_BUTTON6, &CmyDlg::OnBnClickedButton6)
END_MESSAGE_MAP()


// Section A and B:
ofstream myofs("Zp2n31.txt");
int N;  
int ncur; 
CMyTime tim;
CMyTime *ptim1, *ptim2, *ptim3, *ptim4, *ptim5, *ptim6; 
CMyTime *tims; 
char *Names[] = {  
  "Norka ", 
  "Medved ", 
  "Lyra ", 
  "GavGav ",  
  "Tos'ka ", 
  "Zhizel ", 
  "Elka ", 
  "Sharik "
};
char *Suits[] = {  
  "Chau-Chau ", 
  "Boxer ", 
  "Staffordshir ", 
  "Kolli ",  
  "Labrador ", 
  "Chi-HuaHuana ", 
  "Taxa ", 
  "Bolonka "
};


BOOL CmyDlg::OnInitDialog(){
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
  char buf[BUFLEN]; //see
  ptim1 = new CMyTime(14, 24, 34, "Kenguru", "Africa animal");
  ptim2 = new CMyTime(21, 31, 41, "Pinguin", "Sea bird");
  ptim3 = new CMyTime(3, 4, 5, "Shark", "Underwater beast");
  ptim4 = new CMyTime(*ptim3); // copy constructor;
  ptim5 = new CMyTime(7, 12, 53, "Dolphin", "Water animal"); 
  ptim6 = new CMyTime(16, 42, 17, "Medved", "Chi-huana boy"); 
  N = 8; 
  ncur = 0; 
  tims = new CMyTime[N]; 
  for(int n=0; n<N; n++){ 
    tims[n].sethms(rand()%24, rand()%60, rand()%60); 
    tims[n].setn(Names[n]); 
    int len = 2+rand()%4;
    strcpy(buf, "[");
    for(int k=0; k<len; k++)
      strcat(buf, Suits[rand()%8]);
    strcat(buf, "]");
    tims[n].setc(buf);
  }
  myofs << endl << "tims after random initialization:" << endl; 
  for(int n=0; n<N; n++){myofs << tims[n] << endl;} myofs << endl;
  OutArr();
  UpdateData(FALSE); // Update dialog panel;
  return TRUE;  // return TRUE  unless you set the focus to a control
}

void CmyDlg::OnDestroy(){ //see
// Section E, destroying:
  delete ptim1;
  delete ptim2;
  delete ptim3;
  delete ptim4;
  delete ptim5; 
  delete ptim6; 
  delete[] tims;
  myofs.close();
  CDialog::OnDestroy();
}


void CmyDlg::OnSysCommand(UINT nID, LPARAM lParam){
	if ((nID & 0xFFF0) == IDM_ABOUTBOX){
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CmyDlg::OnPaint(){
	if (IsIconic()){
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CmyDlg::OnQueryDragIcon(){
	return static_cast<HCURSOR>(m_hIcon);
}


void CmyDlg::OutArr(){
  char buf[BUFLEN];
  tims[0].MyPrint("[0]=", buf);  SetDlgItemText(IDC_STATIC_OUT20, buf);
  tims[1].MyPrint("[1]=", buf);  SetDlgItemText(IDC_STATIC_OUT21, buf);
  tims[2].MyPrint("[2]=", buf);  SetDlgItemText(IDC_STATIC_OUT22, buf);
  tims[3].MyPrint("[3]=", buf);  SetDlgItemText(IDC_STATIC_OUT23, buf);
  tims[4].MyPrint("[4]=", buf);  SetDlgItemText(IDC_STATIC_OUT24, buf);
  tims[5].MyPrint("[5]=", buf);  SetDlgItemText(IDC_STATIC_OUT25, buf);
  tims[6].MyPrint("[6]=", buf);  SetDlgItemText(IDC_STATIC_OUT26, buf);
  tims[7].MyPrint("[7]=", buf);  SetDlgItemText(IDC_STATIC_OUT27, buf);
}
void CmyDlg::OnBnClickedRUN(){
	// TODO: Add your control notification handler code here
    myofs << "Button RUN pressed." << endl;
    if(UpdateData(TRUE)){ // Retrieve Data;
    SetDlgItemInt(IDC_STATIC_HOU, tim.geth(), TRUE);
    SetDlgItemInt(IDC_STATIC_MIN, tim.getm(), TRUE);
    SetDlgItemInt(IDC_STATIC_SEC, tim.gets(), TRUE);
    SetDlgItemText(IDC_STATIC_NAME, tim.getn());
    SetDlgItemText(IDC_STATIC_COMMENT, tim.getc());
  }
  myofs << endl << "tims after sorting:" << endl; 
  for(int n=0; n<N; n++){myofs << tims[n] << endl;} myofs << endl;
  char buf[BUFLEN], buf1[BUFLEN];
  change(ptim1, ptim2);
  myofs << *ptim1 << endl;
  *ptim4 = !*ptim3; 
  *ptim3 = *ptim4;  
  ptim1->MyPrint("ptim1=", buf);  SetDlgItemText(IDC_STATIC_OUT1, buf);
  ptim2->MyPrint("ptim2=", buf);  SetDlgItemText(IDC_STATIC_OUT2, buf);
  ptim3->MyPrint("ptim3=", buf);  SetDlgItemText(IDC_STATIC_OUT3, buf);
  ptim4->MyPrint("ptim4=", buf);  SetDlgItemText(IDC_STATIC_OUT4, buf);
  *(ptim6) = *ptim1 + *ptim2; 
  int m = *(ptim6); //see
  sprintf(buf1, "ptim1+ptim2= (%6d) ", m);
  ptim6->MyPrint(buf1, buf);  SetDlgItemText(IDC_STATIC_OUT6, buf); 
  OutArr();
 }

void CmyDlg::OnBnClickedButtonRight(){
  // TODO: Add your control notification handler code here
  myofs << "Button RIGHT pressed." << endl;
  int n = incr(ncur, N);
  SetDlgItemInt(IDC_STATIC_HOU, tims[n].geth(), TRUE);
  SetDlgItemInt(IDC_STATIC_MIN, tims[n].getm(), TRUE);
  SetDlgItemInt(IDC_STATIC_SEC, tims[n].gets(), TRUE);
  SetDlgItemText(IDC_STATIC_NAME, tims[n].getn());
  SetDlgItemText(IDC_STATIC_COMMENT, tims[n].getc());
  int n1 = n+1; if(n1 >= N) n1 = n; 
  char buf[BUFLEN], buf1[BUFLEN], buf2[BUFLEN];
  sprintf(buf2, "[%2d]", n);
  tims[n].MyPrint(buf2, buf1);
  strcpy(buf, buf1);
  if(tims[n] < tims[n1]) strcat(buf, "  <  "); 
  else 
  if(tims[n] > tims[n1]) strcat(buf, "  >  "); 
  else
    strcat(buf, "    =    "); 
  sprintf(buf2, "[%2d]", n1);
  tims[n1].MyPrint(buf2, buf1);
  strcat(buf, buf1);
  SetDlgItemText(IDC_STATIC_OUT5, buf);
  *(ptim6) = tims[n] + tims[n1]; //see
  int m = *(ptim6); //see
  sprintf(buf1, "cur+next= (%6d) ", m); //see
  ptim6->MyPrint(buf1, buf); //see
  SetDlgItemText(IDC_STATIC_OUT6, buf); 
  myofs << "Button RIGHT pressed." << endl;
  OutArr();
}

void CmyDlg::OnBnClickedButtonLeft(){
  // TODO: Add your control notification handler code here
  myofs << "Button LEFT pressed." << endl;
  int n = decr(ncur, N);
  SetDlgItemInt(IDC_STATIC_HOU, tims[n].geth(), TRUE);
  SetDlgItemInt(IDC_STATIC_MIN, tims[n].getm(), TRUE);
  SetDlgItemInt(IDC_STATIC_SEC, tims[n].gets(), TRUE);
  SetDlgItemText(IDC_STATIC_NAME, tims[n].getn());
  SetDlgItemText(IDC_STATIC_COMMENT, tims[n].getc());
  int n1 = n+1; if(n1 >= N) n1 = n; 
  char buf[BUFLEN], buf1[BUFLEN], buf2[BUFLEN];
  sprintf(buf2, "[%2d]", n);
  tims[n].MyPrint(buf2, buf1);
  strcpy_s(buf, BUFLEN, buf1);
  if(tims[n] < tims[n1]) strcat(buf, "  <  "); 
  else 
  if(tims[n] > tims[n1]) strcat(buf, "  >  "); 
  else
    strcat_s(buf, BUFLEN, "    =    "); 
  sprintf(buf2, "[%2d]", n1);
  tims[n1].MyPrint(buf2, buf1);
  strcat_s(buf, BUFLEN, buf1);
  SetDlgItemText(IDC_STATIC_OUT5, buf);

  *(ptim6) = tims[n] + tims[n1]; //see
  int m = *(ptim6); //see
  sprintf(buf1, "cur+next= (%6d) ", m); //see
  ptim6->MyPrint(buf1, buf); //see
  SetDlgItemText(IDC_STATIC_OUT6, buf); 
  myofs << "Button LEFT pressed." << endl;
  OutArr();
}


void CmyDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
  MonotIncrease(tims, N, 0); 
  OutArr();
}

void CmyDlg::OnBnClickedButton5()
{
	// TODO: Add your control notification handler code here
  Randomize(tims, N); 
  OutArr();
}

void CmyDlg::OnBnClickedButton6()
{
	// TODO: Add your control notification handler code here
  MonotIncrease(tims, N, 1); 
  OutArr();
}
